from typing import Protocol

from imxInsights.domain.models.imxEnums import AreaNameEnum
from imxInsights.repo.tree.objectTree import ImxObject


class ImxSituationRepoMinimalProtocol(Protocol):
    def get_by_types(self, object_types: list[str]) -> list[ImxObject]:
        pass

    def get_by_puic(self, puic: str) -> ImxObject | None:
        pass

    def get_all(self, areas: list[AreaNameEnum] | None) -> list[ImxObject]:
        pass
